#!/usr/bin/perl -w
#
# test_ATSd - Authorization Server test client
#

package test_ATSd;
use IO::Socket;
use Config::IniFiles;

my($cfg,%cfg);
die('Couldn\'t configure')
    unless $cfg = tie(%cfg, 'Config::IniFiles',
		      -file => '../macs.cfg');

$sock = new IO::Socket::INET(PeerAddr => $cfg{ATS}{s},
			     Proto    => 'tcp');
die 'Error connecting' if !$sock;

$sock->autoflush(1);

if ( defined($ARGV[0]) && $ARGV[0] eq 'q' ) { 
  $writ = "QUIT\n";
  print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
  print "Want: OK\n";
  print 'Resp: ';
  print $sock->getline(),"\n";
  exit;
}

$writ = "PING\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: PONG\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LOGIN guest\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: ERR LOGIN: uid not valid\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LOGIN 2\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK 3 2\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 READ nosuchresource\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: ERR CAN: unknown path\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 READ macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 WRITE macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 OWN macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 ADMIN macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 READ macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 WRITE macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 OWN macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 2 ADMIN macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LOGOUT guest\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: ERR LOGOUT: user not logged in: guest\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LOGOUT 2\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK\n";
print 'Resp: ';
print $sock->getline(),"\n";




$writ = "LOGIN test\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: ERR LOGIN: uid not valid\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LOGIN 3\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK 3\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 3 READ macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 3 WRITE macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 3 OWN macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 3 ADMIN macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 3 READ macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 3 WRITE macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 3 OWN macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 3 ADMIN macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LOGOUT 3\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK\n";
print 'Resp: ';
print $sock->getline(),"\n";




$writ = "LOGIN macs\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: ERR LOGIN: uid not valid\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LOGIN 1\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK 1\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 1 READ macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 1 WRITE macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 1 OWN macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 1 ADMIN macsweb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 1 READ macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 1 WRITE macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 1 OWN macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "CAN 1 ADMIN macsweb/secure\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LOGOUT 1\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK\n";
print 'Resp: ';
print $sock->getline(),"\n";
