// ISAPI AUC.CPP - Implementation file for your Internet Server
//    ISAPI AUC Filter

#include "stdafx.h"
#include "ISAPI AUC.h"

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;



///////////////////////////////////////////////////////////////////////
// The one and only CISAPIAUCFilter object

CISAPIAUCFilter theFilter;


///////////////////////////////////////////////////////////////////////
// CISAPIAUCFilter implementation


// add a secure url to the linked list
int CISAPIAUCFilter::add_securl(char *url) {
	ll_securls *current;
	securls_lock->Lock();
	if ( !securls ) {
		// first entry
		current = securls = (ll_securls *)malloc(sizeof(ll_securls));
	} else {
		for ( current = securls; current->next; current = current->next );
		current = current->next = (ll_securls *)malloc(sizeof(ll_securls));
	}
	current->isxp = 0; // this is always 0 for now
	current->next = NULL;
	current->url = strdup(url);
	current->len = strlen(current->url);
	securls_lock->Unlock();
	return 1;
} // int CISAPIAUCFilter::add_securl(char *url)


// add an ausconn to the linked list
int CISAPIAUCFilter::add_ausconn(char *ausspec) {
	ll_ausconns *current;

	ausconns_lock->Lock();
	if ( !ausconns ) {
		// first entry
		current = ausconns = (ll_ausconns *)malloc(sizeof(ll_ausconns));
	} else {
		// append to list
		for(current = ausconns;current->next;current = current->next);
		current = current->next = (ll_ausconns *)malloc(sizeof(ll_ausconns));
	}
	current->inuse = 0;
	current->next = NULL;
	current->isup = 0;

	// parse aus spec
	for(current->host = ausspec; 
		current->host && *current->host != ':'; 
		current->host++);
	if ( current->host ) {
		// port spec included
		current->host = NULL; current->host++;
		current->port = atoi(current->host);
		current->host = strdup(ausspec);
	} else {
		// no port spec
		current->host = strdup(ausspec);
		current->port = AUS_DEFAULTPORT;
	}

	// Connect
	if ( !aus_connect(current) ) {
		ausconns_lock->Unlock();
		return 0;
	}
	ausconns_lock->Unlock();
	return 0;
} // int CISAPIAUCFilter::add_ausconn(char *ausspec)


// the controlling function for the auc_socket_watcher_thread
UINT __cdecl auc_socket_watcher(LPVOID pParam) {
	ll_ausconns *current;
	CISAPIAUCFilter *f = (CISAPIAUCFilter *)pParam;
	int secs;

	while ( 1 ) {
		for (secs=0; secs<=30; secs++) {
			Sleep(1000); // sleep 1 second
			if ( f->auc_socket_watcher_kill ) {
				// Aaagggh! Tell...mom...i...love...her.. ughhh.
				f->auc_socket_watcher_kill = 0;
				break;
			}
		}
		current = f->ausconns;
		while ( current ) {
			f->ausconns_lock->Lock();
			if ( current->inuse ) {
				// if it's in use, it's good
				f->ausconns_lock->Unlock();
				current = current->next;
				continue;
			}
			current->inuse = 1;
			f->ausconns_lock->Unlock();
			if ( current->isup ) {
				// let's make sure
				if ( f->aus_ping(current) ) {
					// woo hoo
					current->inuse = 0;
					current = current->next;
					continue;
				}
				current->isup = 0;
			}
			if ( f->aus_connect(current) ) {
				// woo hoo
				current->isup = 1;
				current->inuse = 0;
				current = current->next;
				continue;
			}
			current->inuse = 0;
			current = current->next;
		}
	}
} // UINT auc_socket_watcher


// redirect to LIA
DWORD CISAPIAUCFilter::auc_to_LIA( CHttpFilterContext *pCtxt,
						  PHTTP_FILTER_PREPROC_HEADERS pHdrs ) {
	char *buf = (char *)malloc(sizeof(char)*AUC_BUFSIZ),
		*url = (char *)malloc(sizeof(char)*AUC_BUFSIZ),
		*ptr, *urlptr;
	unsigned long len;
	BOOL rv;
	
	strcpy(buf,AUC_LIA_URL);
	for (ptr=buf;*ptr;ptr++);
	strcpy(ptr,"?url=");
	for (ptr=buf;*ptr;ptr++);
	len = AUC_BUFSIZ - (ptr-buf);


	urlptr = url; 
	len = AUC_BUFSIZ;
	pHdrs->GetHeader(pCtxt->m_pFC,"url",url,&len);
	while ( *urlptr ) {
		// urlencode the ? and = in the url
		switch (*urlptr) {
		case '?':
			strcpy(ptr,"%077");
			for (ptr=buf;*ptr;ptr++);
			urlptr++;
			break;
		case '=':
			strcpy(ptr,"%075");
			for (ptr=buf;*ptr;ptr++);
			urlptr++;
			break;
		default:
			*ptr = *urlptr;
			ptr++; urlptr++;
			break;
		} // switch
	}

	strcpy(ptr,"?server=");
	for (ptr=buf;*ptr;ptr++);
	len = AUC_BUFSIZ - (ptr-buf);
	pHdrs->GetHeader(pCtxt->m_pFC,"Host:",ptr,&len);
	if ( !ptr )
		pCtxt->GetServerVariable("SERVER_NAME",ptr,&len);
	for (ptr=buf;*ptr;ptr++);
	len = AUC_BUFSIZ - (ptr-buf);

	strcpy(ptr,"?port=");
	// keep ptr at the '?' for possible removal
	len = AUC_BUFSIZ - ((ptr+strlen(ptr))-buf);
	pCtxt->GetServerVariable("SERVER_PORT",ptr,&len);
	if ( !strncmp(ptr,"80",2) )
		*ptr = NULL;

	len = ptr - buf;
	rv = pCtxt->WriteClient(buf,&len);
	free(buf);
	return rv ? SF_STATUS_REQ_FINISHED : SF_STATUS_REQ_ERROR;
} // DWORD auc_to_LIA


// connect an ausconn
int CISAPIAUCFilter::aus_connect(ll_ausconns *ausconn) {
	// FIXME: should we go ahead and use the CAsyncSocket instead?
	//   Csocket's non-blocking, and this is threads, after all, 
	//   and it's easier to use, but I'm not confident in the MFC
	//   to handle all that for me...
	if ( ausconn->in ) delete ausconn->in;
	if ( ausconn->out ) delete ausconn->out;
	if ( ausconn->file ) delete ausconn->file;
	if ( ausconn->sock ) delete ausconn->sock;
	ausconn->sock = new CSocket;
	if ( !ausconn->sock->Create() ) {
		return 0;
	}
	if ( !ausconn->sock->Connect(ausconn->host,ausconn->port) ) {
		return 0;
	}
	ausconn->file = new CSocketFile(ausconn->sock);
	if ( !ausconn->file ) {
		return 0;
	}
	ausconn->in = new CArchive(ausconn->file,CArchive::load);
	if ( !ausconn->in ) {
		return 0;
	}
	ausconn->out = new CArchive(ausconn->file,CArchive::store);
	if ( !ausconn->out ) {
		return 0;
	}
	if ( aus_ping(ausconn) ) {
		// woo hoo
		return 1;
	}
	return 0;
} // int aus_connect(ll_ausconns *)


// check an ausconn connection
// FIXME: this should take a buf instead of malloc'ing one every time
int CISAPIAUCFilter::aus_ping(ll_ausconns *ausconn) {
	char *buf = (char *)malloc(sizeof(char)*AUC_BUFSIZ),
		*ptr;
	ptr = buf;

	*ausconn->out << "PING\n";
	while ( 1 ) {
		if ( !ausconn->in->Read(ptr,1) ) {
			// EOF
			free(buf);
			return 0;
		}
		if ( *ptr == '\n' ) {
			// EOL
			*ptr = NULL;
			break;
		}
		ptr++;
		if ( ptr == buf + AUC_BUFSIZ - 1) {
			// bounds limit reached
			while ( ausconn->in->Read(ptr,1) && *ptr != '\n' );
			*ptr = NULL;
			break;
		}
	} // read loop
	if ((buf[0] == 'p' || buf[0] == 'P') &&
		(buf[0] == 'o' || buf[0] == 'O') &&
		(buf[0] == 'n' || buf[0] == 'N') &&
		(buf[0] == 'g' || buf[0] == 'G') ) {
		// woo hoo
		free(buf);
		return 1;
	}
	free(buf);
	return 0;
} // int aus_ping(ll_ausconns *)


// FIXME: Should this initialization happen during GetFilterVersion
//   instead of here?
CISAPIAUCFilter::CISAPIAUCFilter()
{
	char *buf = (char *)malloc(sizeof(char)*AUC_BUFSIZ);
	ifstream *cf;

	// init linked lists
	ausconns = (ll_ausconns *)NULL;
	securls = (ll_securls *)NULL;

	// init critical sections
	ausconns_lock = new CCriticalSection;
	securls_lock = new CCriticalSection;

	// parse cf, initting linked lists of securls and AUC connections
	// FIXME: How can I have the user pass me a path to cf? Right now
	//   it's gonna have to be C:\WACA\AUC.ini
	cf = new ifstream("C:\\WACA\\AUC.ini",ios::in|ios::nocreate);
	if ( !cf->is_open() ) {
		delete cf;
		// FIXME: How do I make this thing fail?
		// *this = NULL;
		return;
	}
	while ( 1 ) {
		cf->eatwhite();
		cf->getline(buf,AUC_BUFSIZ);
		if ( buf[0] == '#' ) {
			// comment
			continue;
		}
		switch ( buf[0] ) {
		case 's':
		case 'S':
			// an AUS spec
			add_ausconn(&buf[1]);
			break;
		case 'u':
		case 'U':
			// a secured url
			add_securl(&buf[1]);
			break;
		default:
			// bad syntax
			// FIXME: this shouldn't be ignored
			break;
		} // switch(buf[0])
		if ( cf->eof() )
			break;
	} // parse cf
	cf->close();
	delete cf;

	// start socket_watcher thread
	auc_socket_watcher_kill = 0;
	fp_auc_socket_watcher = auc_socket_watcher;
	auc_socket_watcher_thread = 
		AfxBeginThread(auc_socket_watcher, this);

	return;
} // CISAPIAUCFilter constructor

CISAPIAUCFilter::~CISAPIAUCFilter()
{
	ll_ausconns *curr_ausconn = ausconns,
		*next_ausconn;
	ll_securls *curr_securl = securls,
		*next_securl;

	// stop the socket_watcher thread
	auc_socket_watcher_kill = 1;
	while ( auc_socket_watcher_kill );
	
	// free ausconns list
	ausconns_lock->Lock();
	for(next_ausconn=ausconns->next;curr_ausconn;curr_ausconn=next_ausconn) {
		next_ausconn = curr_ausconn->next;
		delete curr_ausconn->in;
		delete curr_ausconn->out;
		delete curr_ausconn->file;
		delete curr_ausconn->sock;
		free(curr_ausconn->host);
		free(curr_ausconn);
	}
	ausconns_lock->Unlock();

	// free securls list
	securls_lock->Lock();
	for(next_securl=securls->next;curr_securl;curr_securl=next_securl) {
		next_securl = curr_securl->next;
		free(curr_securl->url);
		free(curr_securl);
	}
	securls_lock->Unlock();
} // CISAPIAUCFilter destructor

BOOL CISAPIAUCFilter::GetFilterVersion(PHTTP_FILTER_VERSION pVer)
{
	// Call default implementation for initialization
	CHttpFilter::GetFilterVersion(pVer);

	// Clear the flags set by base class
	pVer->dwFlags &= ~SF_NOTIFY_ORDER_MASK;

	// Set the flags we are interested in
	pVer->dwFlags |= SF_NOTIFY_ORDER_HIGH 
			| SF_NOTIFY_SECURE_PORT | SF_NOTIFY_NONSECURE_PORT
			| SF_NOTIFY_PREPROC_HEADERS;

	// Load description string
	TCHAR sz[SF_MAX_FILTER_DESC_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_FILTER, sz, SF_MAX_FILTER_DESC_LEN));
	_tcscpy(pVer->lpszFilterDesc, sz);
	return TRUE;
} // GetFilterVersion

DWORD CISAPIAUCFilter::OnPreprocHeaders(CHttpFilterContext* pCtxt,
	PHTTP_FILTER_PREPROC_HEADERS pHeaderInfo)
{
	ll_ausconns *ausconn;
	ll_securls *securl;
	char *url = (char *)malloc(sizeof(char)*AUC_BUFSIZ),
		*ip, *cookies, *waca_cookie, *buf, *ptr;
	unsigned long int urlsize = AUC_BUFSIZ;
	int ausup;

	// is this a protected url?
	pHeaderInfo->GetHeader(pCtxt->m_pFC,"url",url,&urlsize);
	for(securl=securls; 
		securl && strncmp(url,securl->url,securl->len); 
		securl=securl->next);
	free(url);
	if ( !securl )
		// nope
		return SF_STATUS_REQ_NEXT_NOTIFICATION;

	// do we have a cookie	
	// urlsize is actually cookiesize now
	urlsize = 4096;
	cookies = (char *)malloc(sizeof(char)*urlsize);
	pCtxt->GetServerVariable("HTTP_COOKIE:",cookies,&urlsize);
	waca_cookie = strstr(cookies,AUC_COOKIE_NAME);
	if ( waca_cookie ) {
		// url is actually next_cookie now
		url = strchr(waca_cookie,';'); 
		if ( url ) *url = NULL;
		waca_cookie = strchr(waca_cookie,'=');
	} else {
		free(cookies);
		return auc_to_LIA(pCtxt,pHeaderInfo);
	}

	// get a good ausconn: if any servers are up,
	//   keep looking til one's free
	ausconn = ausconns;
	ausconns_lock->Lock();
	for (ausup=0; ausconn || ausup; ausconn=ausconn->next) {
		if (!ausconn) {
			// start over
			ausconn = ausconns;
			ausup = 0;
		}
		if ( ausconn->isup )
			ausup++;
		else
			continue;
		if ( !ausconn->inuse ) {
			ausconn->inuse = 1;
			break;
		}
	}
	ausconns_lock->Unlock();
	if ( !ausconn ) {
		// no good ausconns?
		SetLastError(51);
		return SF_STATUS_REQ_ERROR;
	}

	// is the cookie valid?
	urlsize = AUC_BUFSIZ;
	ip = (char *)malloc(sizeof(char)*urlsize);
	pCtxt->GetServerVariable("REMOTE_ADDR",ip,&urlsize);
	*ausconn->out << "ATH " << waca_cookie << " " << ip << "\n";
	buf = ptr = ip;
	while ( 1 ) {
		if ( !ausconn->in->Read(ptr,1) ) {
			// EOF
			free(ip);
			ausconn->isup = 0;
			ausconn->inuse = 0;
			SetLastError(52);
			return SF_STATUS_REQ_ERROR;
		}
		if ( *ptr == '\n' ) {
			// EOL
			*ptr = NULL;
			break;
		}
		ptr++;
		if ( ptr == buf + AUC_BUFSIZ - 1) {
			// bounds limit reached
			while ( ausconn->in->Read(ptr,1) && *ptr != '\n' );
			*ptr = NULL;
			break;
		}
	} // read loop
	if ((buf[0] == 'o' || buf[0] == 'O') &&
		(buf[1] == 'k' || buf[1] == 'K') ) {
		// woo hoo
		ptr = buf + 3;
		// FIXME: I *hope* this changes the request headers and 
		//   not the response headers...
		pHeaderInfo->AddHeader(pCtxt->m_pFC,AUC_WACA_HEADER,ptr);
		free(ip);
		ausconn->inuse = 0;
		return SF_STATUS_REQ_NEXT_NOTIFICATION;
	}
	return auc_to_LIA(pCtxt,pHeaderInfo);
} // On PreprocHeaders

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CISAPIAUCFilter, CHttpFilter)
	//{{AFX_MSG_MAP(CISAPIAUCFilter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/
