
<!--===============================================================-->
<!---------------------MACS integration macros----------------------->
<!--===============================================================-->
<!-- $Id: macs.tpl,v 1.1 2001/09/05 19:45:22 santana Exp $ -->

<!--

TODO:

- there should be a little redundancy regarding the XRS. I don't
  know whether to run it on the local (webx) server for automatic
  speed or on the macs server for automatic redundancy. I'd like
  to think of the XRS almost as part of webx, though, so it's
  coded in here as localhost, but if it stays that way, something
  needs to be done to check that the XRS stays up.

- when creating a new user group in WebX, we should check that the
  group is in macs (except maybe for groups that are for internal
  webx use only, like moderators and hosts. groups for things like
  access to restricted groups, though, should definitely be in macs.)

- when sending out mass mailings (is this even done from within webx?)
  the emails of the various users should be refreshed from macs. If
  this can't happen, then too bad -- we'll work with slightly stale
  data.

-->

%% macro login %%

%% set _url1 "https://login.myco.com/LIA?ura=1;url=" %%
%% set _url2 "http://discussion.myco.com/" %%
%% set _url _url1 & _url2.toUrl %%

%% clearOutput %%
HTTP/1.0 302 Login Required%% crlf %%
Location: %%_url%%%% crlf %%%% crlf %%
%% endmacro %%


%% macro authenticateFilter %%
<!-- let sysop through -->
%% if userIsSysop %%
  %% return %%
%% endif %%
<!-- get the cookie -->
%% set skey envirCookie("test-macs-skey") %%
%% if skey %%
<!-- get the macsuid from the cookie; if there is no valid cookie, drop out -->
  %% set jsCall "checkOreo(""" & skey & """)" %%
  %% set oreoIsValid jsCall.jsEval %%
%% else %%
  %% set oreoIsValid 0 %%
%% endif %%
%% if oreoIsValid > 0 %%
  <!-- if cookie is valid and user is unknown, use the macsuid -->
  <!--   in an rpc call to get the user's login name in macs   -->
  %% set jsCall "getUserDataFromMacs(""LGN"",""" & oreoIsValid & """)" %%
  %% set _userName jsCall.jsEval %%
  <!-- Use the returned login name to lookup the user in webx db-->
  %% set _foundUser userLookup( _userName ) %%
  %% if !_foundUser %%
    <!-- if no user exists, create a new user -->
    <!--   and put the macsuid in the record  -->  
    %% set _foundUser userCreate(_userName) %%
    %% if _foundUser %%
      <!-- update the user's record from macs with rpc calls-->
      %% setAuthor(_foundUser) %%
      %% set author.macsuid oreoIsValid %%
      %% set jsCall "getUserDataFromMacs(""EML"",""" & oreoIsValid & """)" %%
      %% set _usersEmail jsCall.jsEval %%
      %% author.setUserEmail(_usersEmail) %%
      %% set jsCall "getUserDataFromMacs(""LGN"",""" & oreoIsValid & """)" %%
      %% set _firstName jsCall.jsEval %%
      %% set author.firstName _firstName %%
      %% set jsCall "getUserDataFromMacs(""LST"",""" & oreoIsValid & """)" %%
      %% set _lastName jsCall.jsEval %%
      %% set author.lastName _lastName %%
      %% setPath %%
      <!-- log the user in -->
      %% clearOutput %%
      %% _foundUser %%
      %% return %%
    %% else %%
      <!-- ERROR: user not created -->
    %% endif %%
  %% else %%
    <!-- username found; check macsuid-->
    %% setAuthor(_foundUser) %%
    %% if author.macsuid != oreoIsValid %%
      <!-- The username does not match the macs uid -->
      <!--   so delete user and create a new one    -->
      %% setPath %%
      %% _foundUser.userDestroy %%
      %% set _foundUser userCreate( _userName ) %%
      %% if _foundUser %%
        <!-- update the user's record from macs with rpc calls-->
        %% setAuthor(_foundUser) %%
        %% set author.macsuid oreoIsValid %%
        %% set jsCall "getUserDataFromMacs(""EML"",""" & oreoIsValid & """)" %%
        %% set _usersEmail jsCall.jsEval %%
        %% author.setUserEmail(_usersEmail) %%
        %% set jsCall "getUserDataFromMacs(""FST"",""" & oreoIsValid & """)" %%
        %% set _firstName jsCall.jsEval %%
        %% set author.firstName _firstName %%
        %% set jsCall "getUserDataFromMacs(""LST"",""" & oreoIsValid & """)" %%
        %% set _lastName jsCall.jsEval %%
        %% set author.lastName _lastName %%
        %% setPath %%
        <!-- log the user in -->
        %% clearOutput %%
        %% _foundUser %%
        %% return %%
      %% else %%
        <!-- ERROR: user not created -->
      %% endif %%
    %% else %%
      <!-- user found; update the user's record from macs -->
      %% set jsCall "getUserDataFromMacs(""EML"",""" & oreoIsValid & """)" %%
      %% set _usersEmail jsCall.jsEval %%
      %% author.setUserEmail(_usersEmail) %%
      %% set jsCall "getUserDataFromMacs(""FST"",""" & oreoIsValid & """)" %%
      %% set _firstName jsCall.jsEval %%
      %% set author.firstName _firstName %%
      %% set jsCall "getUserDataFromMacs(""LST"",""" & oreoIsValid & """)" %%
      %% set _lastName jsCall.jsEval %%
      %% set author.lastName _lastName %%
      <!--Need to use JS to get the groups the user belongs to -->
      %% setPath %%
      <!-- log the user in -->
      %% clearOutput %%
      %% _foundUser %%
      %% return %%
    %% endif %%
  %% endif %%
%% endif %%
%% if userIsUnknown || userIsGuest %%
  %% return %%
%% endif %%
%% use login %%
%% endmacro %%


%% function getUserDataFromMacs( code, macsuid ) {
  var data;
  data = rpc("http://xrshost.myco.com:42060/RPC2","UPS",code,macsuid);
  if ( data.faultString )
    data = rpc("http://xrshost.myco.com:42060/RPC2","UPS",code,macsuid);
  if ( data.faultString )
    return "Unavailable";
  if ( data.substr(0,2) != "OK" )
    return "Unavailable";
  data = data.substring(3,data.length-1);
  return data;
}
%%


<!-- 
// given a MACS authentication cookie (an oreo) check with the AUS
//   via xml-rpc that it's valid
// try a couple of times before failing...
-->
%% function checkOreo (skey) {
  skey = skey.toString();

  rv = rpc("http://xrshost.myco.com:42060/RPC2","AUS", "ATH", skey, cgi.remote_addr);
  rv = rv.toString();
  if ( rv && rv.substr(0,3) == "YES" )
    return rv.substr(4,rv.length-5)

  rv = rpc("http://xrshost.myco.com:42060/RPC2","AUS", "ATH", skey, cgi.remote_addr);
  rv = rv.toString();
  if ( rv && rv.substr(0,3) == "YES" )
    return rv.substr(4,rv.length-5)

  rv = rpc("http://xrshost.myco.com:42060/RPC2","AUS", "ATH", skey, cgi.remote_addr);
  rv = rv.toString();
  if ( rv && rv.substr(0,3) == "YES" )
    return rv.substr(4,rv.length-5)

  return 0;
} %%


%% function redirect_toLIA {
  response.append("HTTP/1.0 302 Login\n");
  response.append("Status: 302 Login\n");
  var LIAStr = "https://login.myco.com/LIA?ura=1;url=";
  var toGoStr = "http://discussion.myco.com/";
  response.append("Location: " + LIAStr + toGoStr + "\n\n");
} %%




%% macro register %% 
%% set _urlString "https://login.myco.com/URA?url=" %%
%% set _toGoStr "http://discussion.myco.com/" %%
%% set _toGoStr _toGoStr.toUrl %%
%% set _urlString _urlString & _toGoStr %%
%% clearOutput %%
HTTP/1.0 302 Register%% crlf %%
Location: %%_urlString%%%% crlf %%%% crlf %%
%% endmacro %%





%% macro logout %%
%% set _urlString "https://login.myco.com/LOA?url=" %%
%% set _toGoStr "http://discussion.myco.com/" %%
%% set _toGoStr _toGoStr.toUrl %%
%% set _urlString _urlString & _toGoStr %%
%% clearOutput %%
HTTP/1.0 302 Logout%% crlf %%
Location: %%_urlString%%%% crlf %%%% crlf %%
%% endmacro %%





%% macro sysopLogin %%
<html><head><title>Sysop Login</title></head><body>
<form action=%% urlBase %%processSysopLogin method=post>
Password:<input name=password type=password>
</form></body></html>
%% endmacro %%

%% macro processSysopLogin %%
  %% set _so userLookup("sysop") %%
  %% set _sop form("password") %%
  %% if _so.userCheckPassword(_sop) %%
    %% "User.setUser(User.lookup('sysop'))".jsEval %%
<html>
<head><title>Success</title></head>
<body><a href=%% urlBase %%@%% certificate %%@>Success</a></body>
</html>
  %% else %%
    %% use sysopLogin %%
  %% endif %%
%% endmacro %%
