#!/usr/bin/perl -w
#
# test_AUSd - Authentication Server test client
#
# 2.99.BAM
# 7.99.mario
#

package test_ACSd;
use IO::Socket;
use Config::IniFiles;

my($cfg,%cfg);
die('Couldn\'t configure')
    unless $cfg = tie(%cfg, 'Config::IniFiles',
		      -file => '../macs.cfg');

$sock = new IO::Socket::INET(PeerAddr => $cfg{AUS}{s},
			     Proto    => 'tcp');
die 'Error connecting' if !$sock;

$sock->autoflush(1);

if ( defined($ARGV[0]) && $ARGV[0] eq 'q' ) { 
  $writ = "QUIT\n";
  print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
  print "Want: OK\n";
  print 'Resp: ';
  print $sock->getline(),"\n";
  exit;
}

$writ = "PING\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: PONG\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "PUT timeouter tid 1 3.3.3.3\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "ATH timeouter 2.3.3.3\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES tid\n";
print 'Resp: ';
print $sock->getline(),"\n";

print('Waiting for timeouter to expire...'); sleep(1); print("\n");
$writ = "ATH timeouter 2.3.3.3\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "PUT skey uid 600 1.1.1.1\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "ATH skey 1.1.1.1\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES uid\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "ATH skey 1.1.2.1\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES uid\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "ATH wrongskey 1.1.1.1\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "DEL skey\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: OK\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "ATH skey 1.1.1.1\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "DEL skey 1.1.1.1\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: ERR DEL: too many arguments\n";
print 'Resp: ';
print $sock->getline(),"\n";



