package ATC;
 
use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);
use Carp;
use IO::Socket;

use constant HOST => 'atshost';
use constant PORT => 42030;
 
require Exporter;
 
@ISA = qw(Exporter AutoLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
        
);
$VERSION = '0.01';
 
 
# Preloaded methods go here.

sub connect {
    $ATC::sock->close() if(defined($ATC::sock));
    $ATC::sock = new IO::Socket::INET(PeerPort => PORT,
				      PeerAddr => HOST,
				      Proto => 'tcp');
    $ATC::connected = 1;
}

sub can {
    &ATC::connect() unless(defined($ATC::connected) and $ATC::connected == 1);
    $ATC::sock->print("CAN " . join(' ', @_) . "\n");
    return($ATC::sock->getline());
}

# Autoload methods go after =cut, and are processed by the autosplit program.
 
1;
__END__
# Below is the stub of documentation for your module. You better edit it!
 
=head1 NAME
 
ATC - Perl extension for blah blah blah
 
=head1 SYNOPSIS
 
  use ATC;
  blah blah blah
 
=head1 DESCRIPTION
 
The ACL Tree contains all of the permissions for the Web Virtual File System
that is used by web apps, No dependance is made on the real file system
permissions.
 
Blah blah blah.
 
=head1 AUTHOR
 
Blake Mitchell
 
=head1 SEE ALSO
 
perl(1).
 
=cut






