#!/usr/bin/perl
#
use Benchmark;
use Config::IniFiles;
use SOAP::Lite uri => 'urn:SFSd';


#
# Get configured
my($cfg,%cfg);
die("Couldn't configure!")
    unless $cfg = tie(%cfg, 'Config::IniFiles',
		      -file => '../macs.cfg');
for ( keys %{$cfg{env}} ) {
  $ENV{$_} = $cfg{env}{$_};
}

my($s) = new SOAP::Lite;
$s->proxy("http://$cfg{SFS}{s}/");

if ( $ARGV[0] eq 'q' ) {
  $s->quit();
  exit(0);
} 

my @args = ("PING\n");
my @rv;

timethese (100, { 
 		  'Echo' => \&echotest,
		  'AUS ' => \&AUStest,
#		  'ACS ' => \&ACStest,
#		  'ATS ' => \&ATStest
		} );


sub echotest {
    @rv = $s->echo(@args)->result;
    print $rv[0];
} # sub echotest

sub AUStest {
    @rv = $s->aus(@args)->result;
    print $rv[0];
} # sub AUStest

sub ACStest {
    @rv = $s->acs(@args)->result;
    print $rv[0];
} # sub ACStest

sub ATStest {
    @rv = $s->ats(@args)->result;
    print $rv[0];
} # sub ATStest

