#!/usr/bin/perl -w
#
# test_UPSd - User Profile Server test client
#
# $Id: test_UPSd.pl,v 1.3 2002/03/25 04:36:29 santana Exp $
#

package test_ACSd;
use IO::Socket;
use Config::IniFiles;

my($cfg,%cfg);
die('Couldn\'t configure')
    unless $cfg = tie(%cfg, 'Config::IniFiles',
		      -file => '../macs.cfg');

$sock = new IO::Socket::INET(PeerAddr => $cfg{UPS}{s},
			     Proto    => 'tcp');
die 'Error connecting' if !$sock;

$sock->autoflush(1);

if ( defined($ARGV[0]) && $ARGV[0] eq 'q' ) { 
  $writ = "QUIT\n";
  print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
  print "Want: OK\n";
  print 'Resp: ';
  print $sock->getline(),"\n";
  exit;
}


# uid 1 == guest, aid 1 == reserved
my($uid,$aid) = (1,1);


$writ = "PING\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: PONG\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LIST ".($aid + 1)." $uid\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LIST $aid ".($uid + 1)."\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: NO\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "LIST $aid $uid\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES LOGIN EMAIL NAME\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "GET $aid $uid LOGIN\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES " . length("valuea") . "\nvaluea\n";
print 'Resp: ';
if ( ($r=$sock->getline()) =~ /^YES +([0-9]+)$/i ) {
    $sock->read($r,$1,length($r));
}
print $r."\n\n";

$writ = "GET $aid $uid EMAIL\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES " . length("valuea") . "\nvaluea\n";
print 'Resp: ';
if ( ($r=$sock->getline()) =~ /^YES +([0-9]+)$/i ) {
    $sock->read($r,$1,length($r));
}
print $r."\n\n";

$writ = "GET $aid $uid NAME\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES " . length("valuea") . "\nvaluea\n";
print 'Resp: ';
if ( ($r=$sock->getline()) =~ /^YES +([0-9]+)$/i ) {
    $sock->read($r,$1,length($r));
}
print $r."\n\n";

$writ = "PUT $aid $uid keya " . length("valuea") . "\nvaluea";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ,"\n";
print "Want: OK\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "GET $aid $uid keya\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES " . length("valuea") . "\nvaluea\n";
print 'Resp: ';
if ( ($r=$sock->getline()) =~ /^YES +([0-9]+)$/i ) {
    $sock->read($r,$1,length($r));
}
print $r."\n\n";

$writ = "PUT $aid $uid keyb " . length("valueb") . "\nvalueb";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ,"\n";
print "Want: OK\n";
print 'Resp: ';
print $sock->getline(),"\n";

$writ = "GET $aid $uid keyb\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES " . length("valueb") . "\nvalueb\n";
print 'Resp: ';
if ( ($r=$sock->getline()) =~ /^YES +([0-9]+)$/i ) {
    $sock->read($r,$1,length($r));
}
print $r."\n\n";

$writ = "LIST $aid $uid\n";
print 'Sent: (',$sock->write($writ,length $writ),') ',$writ;
print "Want: YES LOGIN EMAIL NAME (keya keyb|keyb keya)\n";
print 'Resp: ';
print $sock->getline(),"\n";


